/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <stdio.h>
#include <slld_targetspecific.h>
#include <slld.h>
#include <slld_hal.h>

BYTE Read_SR1Val();
BYTE Read_SR2Val();
void Read_CRVal();
void readandprintdata(BYTE numtoread, ADDRESS sysaddr);
void programdata(BYTE numtoprogram, ADDRESS sysaddr, uint8 strData);
void Erasedata(ADDRESS sysaddr);
void Read_PPBVal(ADDRESS sysaddr);
void Read_DYBVal(ADDRESS sysaddr);
void Read_ASPVal();
//#define CYP_DEBUG

unsigned long base_addr_g=0;
BYTE wrBuffer[200], buffer[200];
int main()
{
    BYTE stval1=0x00, crval = 0x00, stval2=0x00;
    BYTE srval,srval2, numtoread, i, numtoprogram;
 //   ADDRESS sysaddr1 = 0x0000; 
    ADDRESS sysaddr = 0x80400; // Sector2 Page 3; sector size 256KB; page size 512 Bytes
  //  ADDRESS sysaddr1 = 0xC0400; // Sector3 Page 3; sector size 256KB; page size 512 Bytes
    CyGlobalIntEnable; /* Enable global interrupts. */

    SS_Write(1);
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    SPI_Start();
    UART_Start();
    
    printf("\n\r**********************************************\n\r");
    printf("Interfacing S25FL512S with CYBL10563 - 56LQXI\n\r");
    printf("**********************************************\n\r");
    //Read and print SR1 Value
    srval = Read_SR1Val();
    srval2 = Read_SR2Val();
   // printf("Value of the Status Register is : 0.2%x)",srval);
    //Read and print CR Value
    Read_CRVal();
    
    //Write enable
    numtoread = 6;
    //Read device and manufacturer ID to verify the device
    slld_RDIDCmd(buffer, numtoread);
    printf("Devic ID Read: %0.2x:%0.2x:%0.2x:%0.2x:%0.2x \n\r", 
        buffer[0], buffer[1], buffer[2],buffer[4],buffer[5]);

    //Erase data first
    slld_WRENCmd();
#ifdef CYP_DEBUG
    Read_SR1Val();
#endif
    printf("Erasing data\n\r");
    slld_BlockEraseCmd(sysaddr);
    while(1)
    {
        if(!(Read_SR1Val()&0x01))
            break;
    }
#ifdef CYP_DEBUG
    Read_SR1Val();
#endif
    //Read data from S25FL512S
    numtoread = 100;
    readandprintdata(numtoread, sysaddr);
    //Program S25FL512S
    slld_WRENCmd();
#ifdef CYP_DEBUG
    Read_SR1Val();
#endif
    numtoprogram = 100;
    programdata(numtoprogram, sysaddr, 0);
  //  programdata(numtoprogram, sysaddr1, 0);
    //Read and verify data
    readandprintdata(numtoread,sysaddr);
  //  readandprintdata(numtoread,sysaddr1);
 //   Erasedata(sysaddr);
    //   readandprintdata(numtoread,sysaddr);
    Read_PPBVal(sysaddr);
    Read_DYBVal(sysaddr);
    Read_ASPVal();
    for(i=0;i<50;i++)
    {
        if (buffer[i]==wrBuffer[i])
            LED_Success_Write(0);
        else
        {
            LED_Failure_Write(0);
            while(1);
        }
    }

   for(;;)
    {
        /* Place your application code here. */
    }
}

/*
* Read and print SR1 value
*/
BYTE Read_SR1Val()
{
    BYTE srval=0;
    static int count = 0;
    slld_RDSRCmd(&srval);
   #ifdef CYP_DEBUG
    printf("Status register1 Read%d: %0.2x\n\r", count, srval);

    #endif
    count++;
    return srval;
}

/*
* Read and print SR2 value
*/
BYTE Read_SR2Val()
{
    BYTE srval2=0;
    static int count = 0;
    slld_RDSRCmd(&srval2);
   // #ifdef CYP_DEBUG
    printf("Status register2 Read%d: %0.2x\n\r", count, srval2);

  //  #endif
    count++;
    return srval2;
}
/*
* Read and print CR value
*/
void Read_CRVal()
{
    BYTE crval=0;
    static int count = 0;
    slld_RCRCmd(&crval);
   // #ifdef CYP_DEBUG
    printf("Configuration register Read%d: %0.2x\n\r", count, crval);
 //   #endif
    count++;
    return;
}
/*
* Read and print PPB Access Register value
*/
void Read_PPBVal(ADDRESS sysaddr)
{
    BYTE PPBval=0;
       slld_PPB_RDCmd(sysaddr,&PPBval);
   // #ifdef CYP_DEBUG
    printf("PPB Access register: %0.2x\n\r", PPBval);
 //   #endif
   
    return;
}

/*
* Read and print PPB Access Register value
*/
void Read_DYBVal(ADDRESS sysaddr)
{
    BYTE DYBval=0;
       slld_DYB_RDCmd(sysaddr,&DYBval);
   // #ifdef CYP_DEBUG
    printf("DYB Access register: %0.2x\n\r", DYBval);
 //   #endif
   
    return;
}

/*
* Read and print PPB Access Register value
*/
void Read_ASPVal()
{
    WORD ASPval=0;
       slld_RASPCmd(&ASPval);
   // #ifdef CYP_DEBUG
    printf("Advanced Sector Protection register: %0.2x\n\r", ASPval);
 //   #endif
   
    return;
}

/*
* Read and print data
*/
void readandprintdata(BYTE numtoread, ADDRESS sysaddr)
{
    BYTE i;
    printf("Reading %d data locations, start address %lu\n\r", numtoread, sysaddr);
    
  //  slld_ReadOp(sysaddr, buffer, numtoread);
    slld_Fast_Read_4BCmd(sysaddr,buffer,numtoread);
    printf("Printing data read from address %lu\n\r", sysaddr);
    
    for(i=1;i<(numtoread+1);i++)
    {
        printf("%0.2x:", buffer[i-1]);
        if((i!=0)&&(i%10)==0)
            printf("\n\r");
    }
    return;
}
/*
* Program data
*/
void programdata(BYTE numtoprogram, ADDRESS sysaddr, uint8 strData)
{
    BYTE i;
    printf("Programming %d data locations, start address %lu\n\r", numtoprogram, sysaddr);
    //Fill Write buffer
    for(i=0;i<numtoprogram;i++)
    {
        wrBuffer[i]=strData;
        strData++;
    }
    slld_PPCmd(sysaddr, wrBuffer, numtoprogram);
    while(1)
    {
        if(!(Read_SR1Val()&0x01))
            break;
    }
    return;
}
void Erasedata(ADDRESS sysaddr)
{
    BYTE* devstatus;
    slld_SEOp(sysaddr,&devstatus);
    
}
/* [] END OF FILE */
